/// <reference types="angular" />
/// <reference types="@types/angular-translate" />
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
import { IScope, auto, IPromise, translate } from "angular";
import { StateService, StateObject } from "@uirouter/angularjs";
import { ArrayList } from "@miracledevs/paradigm-ui-web-shared";
import { IAlertService } from "../services/alert.service.interface";
import { ILoggingService } from "../services/logging.service.interface";
import { IMessageBus, RegistrationToken } from "../services/message-bus.service.interface";
import { IModalInstance } from "../services/modal.service.interface";
import { AngularControllerBase } from "./angular-base.controller";
export declare abstract class ControllerBase extends AngularControllerBase {
    protected injector: auto.IInjectorService;
    protected alertService: IAlertService;
    protected stateService: StateService;
    protected messageBus: IMessageBus;
    protected translator: translate.ITranslateService;
    protected logger: ILoggingService;
    protected messageBusTokens: ArrayList<RegistrationToken>;
    protected constructor(scope: IScope, injector: auto.IInjectorService);
    protected initializeServices(): void;
    protected onDestroy(): void;
    protected getService<T>(service: string): T;
    protected open(controller: Function, parameters?: any, staticDialog?: boolean, keyboard?: boolean): IModalInstance;
    protected translate(key: string): string;
    protected call<T>(call: () => IPromise<T>, success?: (result: T) => void, loading?: (loading: boolean) => void, fail?: (reason: any) => void): void;
    protected showErrors(messages: string[]): void;
    protected showWarnings(messages: string[]): void;
    protected showError(message: string): void;
    protected showWarning(message: string): void;
    protected showMessage(message: string): void;
    protected handleException(ex: any): void;
    protected changeState(state: string, params?: any, reload?: boolean): Promise<StateObject>;
    protected registerMessage<T>(messageType: {
        new (...args): T;
    }, handler: (x: T) => void): RegistrationToken;
    protected sendMessage<T>(message: T, token?: RegistrationToken): boolean;
    protected unregisterMessage(token: RegistrationToken): void;
    protected unregisterAllMessages(): void;
}
