"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var directive_1 = require("../decorators/directive");
var base_directive_1 = require("./base.directive");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var AddClassDirective = /** @class */ (function (_super) {
    tslib_1.__extends(AddClassDirective, _super);
    function AddClassDirective() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.restrict = "A";
        return _this;
    }
    AddClassDirective_1 = AddClassDirective;
    AddClassDirective.prototype.create = function (scope, instanceElement, instanceAttributes, controller, transclude) {
        var options = {};
        this.tryGet(options, instanceAttributes, "element");
        this.tryGet(options, instanceAttributes, "addClass");
        if (!paradigm_ui_web_shared_1.ObjectExtensions.isNull(options.element)) {
            var element = $(options.element);
            if (!element.hasClass(options.addClass)) {
                element.addClass(options.addClass);
            }
        }
    };
    AddClassDirective.factory = function () {
        return new AddClassDirective_1();
    };
    AddClassDirective = AddClassDirective_1 = tslib_1.__decorate([
        directive_1.Directive({
            name: "addClass",
            factory: AddClassDirective_1.factory
        })
    ], AddClassDirective);
    return AddClassDirective;
    var AddClassDirective_1;
}(base_directive_1.DirectiveBase));
exports.AddClassDirective = AddClassDirective;
