"use strict";
/*!
 * Paradigm UI Web
 * Copyright (c) 2017 Miracle Devs, Inc
 * Licensed under MIT (https://gitlab.com/miracledevs-paradigm/ui-web-angularjs/blob/master/LICENSE)
 */
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var base_service_1 = require("./base.service");
var service_1 = require("../decorators/service");
var paradigm_ui_web_shared_1 = require("@miracledevs/paradigm-ui-web-shared");
var framework_service_1 = require("./framework.service");
var alert_service_interface_1 = require("./alert.service.interface");
var AlertService = /** @class */ (function (_super) {
    tslib_1.__extends(AlertService, _super);
    function AlertService(logger) {
        var _this = _super.call(this) || this;
        _this.logger = logger;
        _this.alerts = new paradigm_ui_web_shared_1.ArrayList();
        return _this;
    }
    AlertService_1 = AlertService;
    AlertService.prototype.add = function (alertType, message) {
        this.alerts.add(new alert_service_interface_1.Alert(alertType, message));
    };
    AlertService.prototype.addError = function (message) {
        this.add(alert_service_interface_1.AlertType.Error, message);
        this.logger.writeError(message);
    };
    AlertService.prototype.addWarning = function (message) {
        this.add(alert_service_interface_1.AlertType.Warning, message);
        this.logger.writeWarning(message);
    };
    AlertService.prototype.addMessage = function (message) {
        this.add(alert_service_interface_1.AlertType.Message, message);
        this.logger.writeMessage(message);
    };
    AlertService.prototype.remove = function (index) {
        if (index instanceof alert_service_interface_1.Alert)
            this.alerts.remove(index);
        else
            this.alerts.removeAt(index);
    };
    AlertService.prototype.get = function (index) {
        return this.alerts.get(index);
    };
    AlertService.prototype.getAlerts = function () {
        return this.alerts;
    };
    AlertService.factory = function (logger) {
        return new AlertService_1(logger);
    };
    AlertService = AlertService_1 = tslib_1.__decorate([
        service_1.Service({
            name: framework_service_1.FrameworkServices.alertService,
            factory: AlertService_1.factory,
            dependencies: [framework_service_1.FrameworkServices.loggingService]
        })
    ], AlertService);
    return AlertService;
    var AlertService_1;
}(base_service_1.ServiceBase));
exports.AlertService = AlertService;
